// CBitmap.cpp : rbg}bvۑ
//

#include "dxstdafx.h"
#include "CBitmap.h"


// ---------------------------------------------------------------------------
// C[W̕ۑ
// ---------------------------------------------------------------------------
void SaveBitMap( SAVE_BITMAP &sInfo )
{
	BITMAPFILEHEADER  bmfh;
	BITMAPINFOHEADER  bmih;
    DWORD tmp;

	// BITMAPINFOHEADER ̐
	bmih.biSize = sizeof(BITMAPINFOHEADER);
	bmih.biWidth  = sInfo.iWidth;
	bmih.biHeight = sInfo.iHeight;
	bmih.biPlanes = 1;
	bmih.biBitCount = sInfo.iBitCount;
	bmih.biCompression = BI_RGB;
	bmih.biSizeImage = bmih.biWidth * bmih.biHeight * (bmih.biBitCount / 8);
	bmih.biXPelsPerMeter = 0;
	bmih.biYPelsPerMeter = 0;
	bmih.biClrUsed = 0;
	bmih.biClrImportant = 0;

	// BITMAPFILEHEADER ̐
	bmfh.bfType = 0x4D42; // 'BM'
	bmfh.bfReserved1 = bmfh.bfReserved2 = 0;
	bmfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);// f[^̃ItZbg
	bmfh.bfSize = bmfh.bfOffBits + bmih.biSizeImage;// TCY

	// t@C̐
	HANDLE hfile;
	hfile = CreateFile( sInfo.pFileName, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL);
	
	// BITMAPFILEHEADER ̏
    WriteFile(hfile, &bmfh, sizeof(bmfh), &tmp, NULL);
	// BITMAPINFOHEADER ̏
    WriteFile(hfile, &bmih, sizeof(bmih), &tmp, NULL);
	// f[^̏
    SetFilePointer( hfile, bmfh.bfOffBits, NULL, FILE_BEGIN ); // ݈ʒüړ
    GdiFlush();
    WriteFile( hfile, sInfo.pData, bmih.biSizeImage, &tmp, NULL );
    
	// 
	CloseHandle(hfile);
}
